#pragma semicolon 1

#include <ws_store>
#include <sourcemod>

public Plugin:myinfo = 
{
	name	= "STORE (Gravity)",
	author	= "wS (World-Source.Ru)",
	version = "1.1"
};

new g_Price, Float:g_fGravity, g_CategoryID, g_ItemID;
new bool:g_bAccess[MAXPLAYERS + 1];

public OnPluginStart()
{
	CreateTimer(1.0, START);
}

public OnPluginEnd()
{
	if (g_CategoryID > 0 && !STORE_DeleteCategoryByID(g_CategoryID, true) && g_ItemID > 0)
		STORE_RemoveItemFromCategory(g_CategoryID, g_ItemID);
}

public STORE_Loaded()
{
	g_CategoryID = 0; g_ItemID = 0;
	decl String:PluginName[150]; PluginName[0] = '\0'; GetPluginFilename(GetMyHandle(), PluginName, 150);
	ServerCommand("sm plugins reload \"%s\"", PluginName);
}

public Action:START(Handle:timer)
{
	/////
	new Handle:kv = CreateKeyValues("store_gravity");

	if (!FileToKeyValues(kv, "cfg/store/modules/store_gravity.txt"))
		SetFailState("Error in cfg/store/modules/store_gravity.txt");

	decl String:CategoryName[STORE_CATEGORY_LENGTH];
	KvGetString(kv, "CategoryName", CategoryName, STORE_CATEGORY_LENGTH);
	if (TrimString(CategoryName) < 1)
		SetFailState("Категория не указана");

	new bool:bCategoryExist = (g_CategoryID = STORE_GetCategoryID(CategoryName)) > 0;
	decl String:Text[STORE_ITEMTEXT_LENGTH], String:str_flag[10];

	if (!bCategoryExist)
	{
		KvGetString(kv, "CategoryText", Text, STORE_ITEMTEXT_LENGTH);
		KvGetString(kv, "CategoryFlag", str_flag, 10);

		if ((g_CategoryID = STORE_CreateCategory(CategoryName, Text, str_flag)) < 1)
			SetFailState("Не удалось создать категорию '%s'", CategoryName);
	}

	g_Price = KvGetNum(kv, "price");
	KvGetString(kv, "ItemText", Text, STORE_ITEMTEXT_LENGTH);
	if (TrimString(Text) > 0)
	{
		KvGetString(kv, "ItemFlag", str_flag, 10);
		if ((g_ItemID = STORE_AddItemToCategory(g_CategoryID, Text, g_Price, true, MyCallBack, str_flag)) < 1)
		{
			if (!bCategoryExist)
			{
				STORE_DeleteCategoryByID(g_CategoryID, true);
				g_CategoryID = 0;
			}
			SetFailState("Не удалось добавить функцию '%s'", Text);
		}
	}
	else if (bCategoryExist)
		SetFailState("Укажите уникальное название категории или используйте ItemText");

	if ((g_fGravity = KvGetFloat(kv, "gravity")) < 0.1) g_fGravity = 0.1;
	else if (g_fGravity > 0.9) g_fGravity = 0.9;

	CloseHandle(kv);
	/////

	HookEvent("round_start", round_start, EventHookMode_PostNoCopy);
	CreateTimer(1.0, timer_CallBack, _, TIMER_REPEAT);

	return Plugin_Stop;
}


///


public MyCallBack(client, const String:steamid[], CategoryID, ItemID, ItemPrice)
{
	if (ItemID == g_ItemID)
		wS_OnClientSelect(client, LastMenuItem:MI_InCategory);
}

public STORE_OnClientSelectEmptyCategory(client, const String:steamid[], CategoryID)
{
	if (CategoryID == g_CategoryID)
		wS_OnClientSelect(client, LastMenuItem:MI_Main);
}

stock wS_OnClientSelect(client, LastMenuItem:MI)
{
	if (!IsPlayerAlive(client))
	{
		PrintCenterText(client, "Вы мертвы");
		STORE_ShowMenu(client, MI);
		return;
	}

	if (g_bAccess[client])
	{
		PrintCenterText(client, "Вы уже купили гравитацию");
		STORE_ShowMenu(client, MI);
		return;
	}

	if (g_Price > 0)
	{
		new credits = STORE_GetCredits(client);

		if (credits < g_Price)
		{
			PrintCenterText(client, "Вам не хватает %d кр", (g_Price - credits));
			STORE_ShowMenu(client, MI);
			return;
		}

		if (!STORE_SetCredits(client, (credits - g_Price)))
		{
			LogError("Не удалось установить кредиты игроку '%N'", client);
			return;
		}
	}

	g_bAccess[client] = true;
	SetEntityGravity(client, g_fGravity);
	PrintToChat(client, "\x04Гравитация активирована");

	STORE_ShowMenu(client, MI);
}


///


public OnClientConnected(client)
{
	g_bAccess[client] = false;
}

public OnClientDisconnect(client)
{
	g_bAccess[client] = false;
}

public round_start(Handle:event, const String:name[], bool:silent)
{
	for (new i = 1; i <= MaxClients; i++)
	{
		g_bAccess[i] = false;
		if (IsClientInGame(i)) SetEntityGravity(i, 1.0);
	}
}

public Action:timer_CallBack(Handle:timer)
{
	for (new i = 1; i <= MaxClients; i++)
	{
		if (g_bAccess[i] && IsClientInGame(i) && IsPlayerAlive(i))
			SetEntityGravity(i, g_fGravity);
	}
	return Plugin_Continue;
}